#!/usr/bin/perl

#global defines
$PATH_CONF="/home/dottogo/opensrs286";
$PATH_LIB="$PATH_CONF/lib";
$path_templates="$PATH_CONF/templates/whois";
$cgi=$ENV{SCRIPT_NAME};
%in = ();
my @out=();
my $data=""; 
%tlds=( 
	".org" => "whois.pir.org",
	".biz"=>"whois.neulevel.biz",
	".info"=> "whois.afilias.info",
	".name"=>"whois.nic.name",	
	".mil" => "whois.nic.mil",
        ".edu" => "whois.educause.edu",
	".gov" => "whois.nic.gov",
	".us" => "whois.nic.us",
	".mx" => "whois.nic.mx",
	".ca" => "whois.cira.ca",
	".uk" => "whois.nic.uk",
	".dk" => "whois.dk-hostmaster.dk",
	".de" => "whois.nic.de",
	".be" => "whois.ripe.net",
	".at" => "whois.aco.net",
	".cz" => "whois.ripe.net",
	".fr" => "whois.nic.fr",
	".ch" => "whois.nic.ch",
	".net.au" =>  "whois.net.au",
	".au" => "whois.aunic.net",
	".br" => "whois.registro.br",
	".cx" => "whois.nic.cx",
	".nu" => "whois.nic.nu",
	".cc" => "whois.nic.cc",
	".as" => "whois.nic.as",
	".to" => "whois.tonic.to",
	".ws" => "whois.nic.ws",
	".ac" => "whois.nic.ac",
	".tc" => "whois.adamsnames.tc",
	".vg" => "whois.adamsnames.tc",
	".ms" => "whois.adamsnames.tc",
	".gs" => "whois.adamsnames.tc",
	".tf" => "whois.adamsnames.tc",
	".bm" => "rwhois.ibl.bm",
	".no" => "whois.ripe.net",	
	".jp" => "whois.nic.ad.jp",	
 	".it" => "whois.nic.it",	
        ".nl" => "whois.domain-registry.nl",	    
        ".se" => "whois.nic-se.se",
        ".hk" => "whois.hknic.net.hk",		
        ".tj" => "whois.nic.tj",	   
        ".sg" => "whois.nic.net.sg",
        ".th" => "whois.thnic.net",
        ".il" => "whois.isoc.org.il",
        ".kr" => "whois.krnic.net",
        ".hu" => "whois.nic.hu",
        ".is" => "whois.isnet.is", 
        ".ru" => "whois.ripn.ru",
        ".st" => "whois.nic.st",
        ".lu" => "whois.restena.lu",
        ".si" => "whois.arnes.si",     
        ".hm" => "whois.registry.hm",  
	".li" => "whois.nic.li",        
	".gm" => "whois.ripe.net",    
 	#".tw" => "whois.seed.net.tw",
 	".in" => "whois.ncst.ernet.in", 
 	".nz" => "whois.domainz.net.nz",
      );
my $RWHOIS_PORT = 4321;
my $WHOIS_PORT = 43;
my $ctype_sent = FALSE;

use constant TRUE      => 1;
use constant FALSE     => '';

my $gtlds        = '(com|net)';
my $internic     = 'whois.crsnic.net';
my $default_host = $internic;    
my $portname = FALSE;
my $protoname = 'tcp';
my $link_host = '';

#reqd modules
use IO::Socket;
use CGI ':cgi-lib';
$tlds="(.COM, .NET,";
$tld_no=2;
foreach my $key (sort keys %tlds) 
{
$key=uc($key);
$tlds.=" $key,";
$tld_no++;
}
chop $tlds;
$tlds=")";

# read in the form data
ReadParse(\%in);

#main program

print "Content-type: text/html\n\n";

if ($in{'domain'} eq "") {
    my %HTML = (tlds=>$tlds,
    		tldno=>$tld_no,
    		cgi=> $cgi
    		);
    print_form("$path_templates/whois.html",\%HTML);	
  } else {
	
	@out=&whois($in{domain});

   foreach $_ (@out) {
	$data.="$_ <BR>\n";
}
   


    my %HTML = (tlds=>$tlds,
    		tldno=>$tld_no,
    		cgi=> $cgi,
    		whois=>$data,
    		);
    print_form("$path_templates/whoisresult.html",\%HTML);	

}
#functions


sub whois
{
my $domain = shift;
my $tld = '';
my $r_host = $host;
my $r_port = $portname;
my $r_default_host = $default_host;
$r_port = ($r_host =~ /rwhois/) ? 4321 : 43 unless $r_port;

$domain =~ s/\.+$//;



my @rc = ();
my $subrec = '';
# do we need a different default server?
if(!$r_host and (lc $domain) =~ /\.([a-z0-9\-]+)$/) {
  $tld = $1;
  if($tld !~ /$gtlds/) {
    my $tld_host = find_tld($domain);
    $r_default_host = $tld_host if $tld_host;
    if (not $tld_host)
    {
    $data.="This TLD is not supported.<br>\n";
    $ns=1;
         } 
    } 
  }

if ($ns != 1)
{

unless($r_host) {
  $r_host = FALSE;
  @rc = whois_fetch($r_default_host, $domain, $r_port);

 
    grep { /Whois Server:\s*(.*)/i and $r_host = $1 } @rc;   # look for the referral
       if ($r_host)
    {
      foreach $_ (@rc) {
	$data.="$_ <BR>\n";
}
        }
  }      
 }
 else
 {
 $r_host=FALSE;
 }

if($r_host) {
  $r_port = $portname unless $r_port;
  @rc = whois_fetch($r_host, $domain, $r_port);
  grep {/\((.*-DOM)\).*$domain$/i and $subrec = $1 } @rc;
  }

if($subrec) {
  @rc = whois_fetch($r_host, $subrec, $r_port);
  }

return @rc;
}


sub whois_fetch
{
my $host = shift;
my $domain = shift;
my $port = shift;
my ($uri, $handle);
my @rc;

my $rs = IO::Socket::INET->new(
    PeerAddr  => $host,
    PeerPort  => $port,
    Proto     => $protoname
  );

unless($rs) {
$data.="unable to connect to $host <br>\n";
return ;
  }

$rs->autoflush(1);

if($host =~ /nic\.ad\.jp$/) { 
  $domain .= '/e' 
  }

if($domain =~ /^[a-z\d\-]+\.[a-z\d\-]+$/ and $host eq $internic) { 
  $rs->print("domain $domain\r\n"); 
  }
else { $rs->print("$domain\r\n"); }

while(<$rs>) { 
  push @rc, $_;
  }

$link_host = $host;
return @rc;
}

sub find_tld
{
my $domain = lc shift;
my $tld = '';
my $server = '';

foreach $key (%tlds)
{        
if (substr($domain, 0 - length($key)) eq $key) {
    $tld = $key;
    $server = $tlds{$key};
    $flag=1;
     last;
    }
  }         
if ($flag==1)
{
return $server;
}
else
{
return 0;
}
}



        ##########################################################################
# substitute values on the specified template and print it to the client

# an optional 'type' arg can be passed: 'framed' specifies to pull in base.html
# as the outer frame and the given template as the inner frame
# 'single' specifies to use the given template alone
# the default behavior is 'framed'
sub print_form {
    
    my ($type,$content);

    my @args = @_;
    my ($template,$HTML) = @args[0,1];
    if ($args[2]) { $type = $args[2] }
    else { $type = 'framed' }

    

    if ($type eq 'framed') {
	$HTML->{CONTENT} = get_content("$template",$HTML);
    
	open (FILE, "<$path_templates/base.html") or die "Couldn't open $path_templates/base.html: $!\n";
	while (<FILE>) {
	    s/{{(.*?)}}/$HTML->{$1}/g;
	    $content .= $_;
	}
	close FILE;
    } else {
	open (FILE, "<$template") or die "Couldn't open $template: $!\n";
	while (<FILE>) {
	    s/{{(.*?)}}/$HTML->{$1}/g;
	    $content .= $_;
	}
	close FILE;
    }
    print $content;
}

####################################################
# grab the contents of a template, substitute any supplied values, and return
# the results
sub get_content {
    
    my $content;
    
    my ($template,$HTML) = @_;
    open (FILE, "<$template") or die "Couldn't open $template: $!\n";
    while (<FILE>) {
	s/{{(.*?)}}/$HTML->{$1}/g;
	$content .= $_;
    } 
    close FILE;
    
    return $content;
    
}
